## try http:// if https:// URLs are not supported
source("https://bioconductor.org/biocLite.R")
biocLite("ggtree")

## try http:// if https:// URLs are not supported
source("https://bioconductor.org/biocLite.R")
biocLite("Biostrings")

library(tidyverse)
library(ggtree)
library(Biostrings)
library(RColorBrewer)
library(colorspace)
library(treeio)
library(ggplot2)

setwd("")

tree <- read.tree("LygusMin10_14.nwk")
tree
trait <- read.table("LygusMin10_14_Hier2.txt", header=T)

# create the basic plot

display.brewer.all()

##color
require(RColorBrewer) 
brew10 <- brewer.pal(10, "Paired")
rcol <- colors()
brew10rgb <- col2rgb(brew10)
allrgb <- col2rgb(rcol)
apply(t(brew10rgb), 1, paste, collapse="$$") %in% apply(t(allrgb), 1, paste,collapse="$$")
brew10rgb[,1]
fltr <- allrgb[1,]==141
allrgb[,fltr]
fltr <- allrgb[2,]==211
allrgb[,fltr]
col.dist <- function(inp, comp) sum( abs(inp - col2rgb(comp) ) )

colors()[ apply(col2rgb(brew10), 2, 
                function(z) which.min( sapply(colors(), 
                                              function(x) col.dist(inp=z, comp=x) ) ) ) ]

###Lygus ddRAD data

p <- ggtree(tree)+ geom_treescale(width=0.02, x=0.1, y=13)
p
pp <- p + geom_cladelabel(node=22, label="Lygus keltoni", offset=0.16, align=TRUE, angle=270, offset.text=.03, extend=0.42, barsize=1.2)+ 
  geom_cladelabel(node=25, label="Lygus elisus", offset=0.16, align=TRUE, angle=270, offset.text=.03, extend=0.42,  barsize=1.2) + 
  geom_cladelabel(node=16, label="Lygus borealis", offset=0.16, align=TRUE, angle=270, offset.text=.03, extend=0.42,  barsize=1.2) +
  xlim(0,0.45)+
  ylim(0,16) +
  geom_tiplab(align=TRUE, linesize=.5) +
  theme(legend.text = element_text(size = 11))
pp
ppp <- gheatmap(pp, trait, colnames=TRUE, hjust=0, offset=0.06, width=.3, font.size=4, colnames_angle=50, colnames_position="top") +
scale_fill_manual(breaks=c("Manitoba", "Alberta", "Alfalfa", "Clover", "Mustard", "June", "August"),
                  values=c("dodgerblue3", "lightsalmon", "goldenrod1","firebrick2", "khaki1", "lightskyblue2", "darkred"))
ppp

###Peristenus ddRAD data

setwd("")

tree <- read.tree("PeriMin10_19.nwk")
tree
trait <- read.table("PeriMin10_19_Hier.txt", header=T)

####when first viewing tree, code geom_text(aes(label=node), hjust=-.3) into first line to see node #s so you can 
####determine which node to choose for cladelabel below

p <- ggtree(tree)+ geom_treescale(width=0.02, x=0.05, y=17)
p
pp <- p + geom_cladelabel(node=21, label="Peristenus", offset=0.16, align=TRUE, angle=270, offset.text=.03, extend=0.42, barsize=1.2)+ 
  geom_cladelabel(node=31, label="Peristenus", offset=0.16, align=TRUE, angle=270, offset.text=.03, extend=0.42,  barsize=1.2) + 
  xlim(0,0.43)+
  ylim(0,21) +
  geom_tiplab(align=TRUE, linesize=.5) +
  theme(legend.text = element_text(size = 11))
pp
ppp <- gheatmap(pp, trait, colnames=TRUE, hjust=0, offset=0.06, width=.3, font.size=4, colnames_angle=50, colnames_position="top") +
  scale_fill_manual(breaks=c("Manitoba", "Alberta", "Alfalfa", "Clover", "Mustard", "borealis", "keltoni", "elisus", "June", "August"),
                    values=c("dodgerblue3", "lightsalmon",  "goldenrod1","mediumorchid1","firebrick2", "orchid4", "khaki1", "plum1","lightskyblue2", "darkred"))
ppp

###Lygus COI


###Peristenus COI

